--- devils-advocate.pt-br.po	2018-02-08 16:09:26.792454277 -0200
+++ devils-advocate.pt-br2.po	2018-02-08 17:08:52.715816419 -0200
@@ -6,7 +6,7 @@
 msgstr ""
 "Project-Id-Version: devils-advocate.html\n"
 "POT-Creation-Date: 2017-11-07 21:25+0000\n"
-"PO-Revision-Date: 2018-01-17 23:05-0200\n"
+"PO-Revision-Date: 2018-02-08 17:08-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -14,7 +14,7 @@
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
-"X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Generator: Poedit 1.8.7.1\n"
 
 #. type: Content of: <title>
 msgid "Devil's Advocate - GNU Project - Free Software Foundation"
@@ -39,7 +39,7 @@
 "Se fazer de advogado do diabo significa desafiar uma posição ao dizer o que "
 "um adversário hipotético diria. Eu encontro isso com frequência em "
 "entrevistas e sessões de perguntas e respostas, e muitas pessoas acreditam "
-"que esta é uma boa maneira de colocar uma posição polêmica no teste. O que "
+"que esta é uma boa maneira de colocar uma posição polêmica em teste. O que "
 "realmente faz é colocar a posição controversa em desvantagem."
 
 #. type: Content of: <p>
@@ -87,8 +87,8 @@
 "distraí-los da questão, impedindo-a de ser devidamente levantada. Se isso "
 "faz com que minhas palavras pareçam significar algo que a audiência vai "
 "condenar, e que ninguém presente é realmente a favor, talvez eu precise de "
-"uma longa explicação para voltar ao bom caminho. Pode não haver tempo para "
-"isso, ou o público pode perder o foco."
+"uma longa explicação para voltar ao assunto. Pode não haver tempo para isso, "
+"ou o público pode perder o foco."
 
 #. type: Content of: <p>
 msgid ""
@@ -139,7 +139,7 @@
 "Se você sabe o que esses adversários me disseram, ou se você é habilidoso em "
 "imaginá-los, você diria as mesmas coisas que eles. Essas declarações podem "
 "distrair o público e bloquear a consideração da questão, como se um "
-"verdadeiro adversário os tivesse dito. Mas se você não é realmente meu "
+"verdadeiro adversário as tivesse dito. Mas se você não é realmente meu "
 "adversário, esse resultado pode não ser o que você realmente quer. Se o seu "
 "objetivo fosse lançar luz sobre a questão, sua abordagem depõe contra você "
 "mesmo."
@@ -220,17 +220,17 @@
 "webmasters@gnu.org&gt;</a>."
 
 #
-#.  TRANSLATORS: Ignore the original text in this paragraph,
-#.         replace it with the translation of these two:
-#.         We work hard and do our best to provide accurate, good quality
-#.         translations.  However, we are not exempt from imperfection.
-#.         Please send your comments and general suggestions in this regard
-#.         to <a href="mailto:web-translators@gnu.org">
-#.         &lt;web-translators@gnu.org&gt;</a>.</p>
-#.         <p>For information on coordinating and submitting translations of
-#.         our web pages, see <a
-#.         href="/server/standards/README.translations.html">Translations
-#.         README</a>. 
+#. TRANSLATORS: Ignore the original text in this paragraph,
+#. replace it with the translation of these two:
+#. We work hard and do our best to provide accurate, good quality
+#. translations.  However, we are not exempt from imperfection.
+#. Please send your comments and general suggestions in this regard
+#. to <a href="mailto:web-translators@gnu.org">
+#. &lt;web-translators@gnu.org&gt;</a>.</p>
+#. <p>For information on coordinating and submitting translations of
+#. our web pages, see <a
+#. href="/server/standards/README.translations.html">Translations
+#. README</a>.
 #. type: Content of: <div><div><p>
 msgid ""
 "Please see the <a href=\"/server/standards/README.translations.html"
@@ -266,7 +266,7 @@
 "Traduzido por: Rafael Fontenelle <a href=\"mailto:rafaelff@gnome.org\">&lt;"
 "rafaelff@gnome.org&gt;</a>, 2018."
 
-#.  timestamp start 
+#. timestamp start
 #. type: Content of: <div><p>
 msgid "Updated:"
 msgstr "Última atualização:"